<?php

namespace Drupal\shy_one_time\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * Provides a base implementation for RouteSubscriber.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * The module handler service.
   *
   * @var \Drupal\Core\Extension\ModuleHandlerInterface
   */
  protected $moduleHandler;

  /**
   * Constructs a RouteSubscriber object.
   *
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler service.
   */
  public function __construct(ModuleHandlerInterface $module_handler) {
    $this->moduleHandler = $module_handler;
  }

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {

    if ($route = $collection->get('user.reset')) {
      if ($this->moduleHandler->moduleExists('passwordless')) {
        $route->setDefaults([
          '_controller' => '\Drupal\shy_one_time\Controller\ShyPasswordlessController::resetPass',
          '_title' => 'Log-in',
        ]);
      }
      else {
        $route->setDefaults([
          '_controller' => '\Drupal\shy_one_time\Controller\ShyController::resetPass',
          '_title' => 'Log-in',
        ]);
      }
    }
  }

}
